FixedDivisor is sometimes surprisingly slow
Status: Closed Start date: 20 Nov 2023

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Improving Estimated time: 2.22 hours

Target version: CoCoALib-0.99850 Spent time: 2.25 hours

Description

FixedDivisor can sometimes be unexpectedly slow.

f := product([c[1]*x-c[2] | c in (1..50)><(1..50) and gcd(c) = 1]);

FixedDivisor(f); -- a bit slow; much worse with 100 instead of 50

 

Maybe make the evaluation code in SparsePolyOps-cyclotomic.C publicly available & use it?

Related issues:

Related to CoCoALib - Feature #1770: Evaluate polynomial function/class Closed 21 Nov 2023

History

#1 - 21 Nov 2023 23:15 - John Abbott

- Related to Feature #1770: Evaluate polynomial function/class added

#2 - 27 Nov 2023 19:41 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott

- % Done changed from 0 to 60

I have changed the code to use the new prototype evaluation code (see issue #1770), and it is now usefully faster :-)

[for the example in the description: previously about 15s; now about 1s]

This is probably good enough: most of the time is spent evaluating the polynomial...

Not sure if we can be cleverer about which points to evaluate at?  [ i.e. just use a subset of the points we actually use]

#3 - 01 Dec 2023 21:29 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 60 to 90

I regard this as fixed: the remaining work is in issue #1770

#4 - 22 Dec 2023 20:57 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 2.22 h

It is now good enough to be closed.
